unit mycluster;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Grids, httpsend;

type

  { TfrmMyCluster }
  TfrmMyCluster = class(TForm)
    btnTest: TButton;
    Memo1: TMemo;
    procedure btnTestClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    Running:Boolean;
  public
    { public declarations }
    csCritical  : TRTLCriticalSection;
  end;

type
  { TScanThread }

  TScanThread = class(TThread)
  protected
    procedure Execute; override;
end;
var
  frmMyCluster: TfrmMyCluster;

implementation

procedure writememo(aText:string);
begin
  if (assigned(frmMyCluster)) then begin
    frmMyCluster.Memo1.lines.add(aText);
  end;
  //sleep(100);
end;

{ TScanThread }

procedure TScanThread.Execute;
var i,p1,Nr:integer;
begin
  EnterCriticalsection(frmMyCluster.csCritical);
  try

    FreeOnTerminate      := True;
    frmMyCluster.Running := True;
    (*for i:=1 to 10 do begin
      writememo('Lauf '+inttostr(i));
    end;*)

    p1:=1;
    Nr:=1;
    while (true) do begin
      writememo('Test '+inttostr(Nr));
      Inc(Nr);
      if (Nr>90) then
        break;
    end;

    (*p1:=1;
    Nr:=1;
    repeat
      writememo('Test '+inttostr(Nr));
      Inc(Nr);
    until (p1=0)or(Nr>90);
    *)

  finally
    LeaveCriticalsection(frmMyCluster.csCritical);
    frmMyCluster.Running := False;
  end;
end;

procedure TfrmMyCluster.btnTestClick(Sender: TObject);
var
  ScanThread : TScanThread = nil;
begin
  if ScanThread = nil then
    ScanThread := TScanThread.Create(True);
  ScanThread.Start
end;

procedure TfrmMyCluster.FormCreate(Sender: TObject);
begin
  InitCriticalSection(csCritical);
end;


initialization
{$I mycluster.lrs}


end.



(*
**
Gtk:ERROR:gtktextview.c:3571:gtk_text_view_validate_onscreen: assertion failed: (text_view->onscreen_validated)
Abgebrochen



(cqrlog:16252): Gtk-WARNING **: Invalid text buffer iterator: either the iterator is uninitialized, or the characters/pixbufs/widgets in the buffer have been modified since the iterator was created.
You must use marks, character numbers, or line numbers to preserve a position across buffer modifications.
You can apply tags and insert marks without invalidating your iterators,
but any mutation that affects 'indexable' buffer contents (contents that can be referred to by character offset)
will invalidate all outstanding iterators


*)

